#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityMonsterItemCFG.h"
std::auto_ptr<M_ActivityMonsterItemCFG> M_ActivityMonsterItemCFG::msSingleton(nullptr);

int M_ActivityMonsterItemCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityMonsterItemCFGData* M_ActivityMonsterItemCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityMonsterItemCFGData>& M_ActivityMonsterItemCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityMonsterItemCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityMonsterItemCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityMonsterItemCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mItemName = element->Attribute("ItemName");
		data.mGrade = element->IntAttribute("Grade");
		data.mItemId = element->IntAttribute("ItemId");
		data.mHurtMin = element->IntAttribute("HurtMin");
		data.mHurtMax = element->IntAttribute("HurtMax");
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityMonsterItemCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMonsterItemCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityMonsterItemCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityMonsterItemCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityMonsterItemCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readString(L, "ItemName", data.mItemName);
		LuaCfgHelper::readInt(L, "Grade", data.mGrade);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "HurtMin", data.mHurtMin);
		LuaCfgHelper::readInt(L, "HurtMax", data.mHurtMax);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityMonsterItemCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityMonsterItemCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityMonsterItemCFG* M_ActivityMonsterItemCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityMonsterItemCFG());
	}
	return msSingleton.get();
}

void M_ActivityMonsterItemCFG::Release()
{
	msSingleton.reset(nullptr);
}
